# -*- coding: UTF-8 -*-
import Tkinter
import obj
import random
import someshit
import tkFont

class Gcanvas(Tkinter.Canvas):
    def __init__(self, root, reboot = None,speedentry = None,\
                 accelentry = None,texts=None, *args,**kwrds):

        self.data = someshit.readdata()
        self.texts = texts
        width = int(self.data["width"])
        height = int(self.data["height"])
        c_pad = int(self.data["pad"])
        fps = int(self.data["fps"])
        c_xcenter = width/2
        c_ycenter = height/2
        fr_width = int(self.data["framewidth"])
        fr_length = min(width,height)-2*c_pad

        
        Tkinter.Canvas.__init__(self, root, width = width,\
                                height = height, bg=self.data["gamecolor"])
        self.reboot = reboot
        blocks = []
        mainrect=[]
        speed = speedentry.get()
        accel = accelentry.get()
        num_blocks = int(self.data["blocks"])
        
        frame = complex(width,height)
        obj.Movingrect(self,x=c_xcenter, y= c_ycenter-fr_length/2+fr_width/2,\
                        width = fr_length, height = fr_width, blocks = blocks,\
                        mainrect = mainrect,frame=frame,\
                        color= self.data["framecolor"],fps=fps)
        obj.Movingrect(self,x=c_xcenter, y=c_ycenter+fr_length/2-fr_width/2,\
                        width = fr_length, height = fr_width, blocks = blocks,\
                        mainrect = mainrect,frame=frame,\
                        color= self.data["framecolor"],fps=fps)
        obj.Movingrect(self,x=c_xcenter-fr_length/2+fr_width/2, y=c_ycenter,\
                        width = fr_width, height = fr_length, blocks = blocks,\
                        mainrect = mainrect,frame=frame,\
                        color= self.data["framecolor"],fps=fps)
        obj.Movingrect(self,x=c_xcenter+fr_length/2-fr_width/2, y=c_ycenter,\
                        width = fr_width, height = fr_length, blocks = blocks,\
                        mainrect = mainrect,frame=frame,\
                        color= self.data["framecolor"],fps=fps)

        for x in xrange(num_blocks):
            obj.Movingrect(self, x=int(self.data["mainblocksize"]),\
                            y=int(self.data["mainblocksize"]),\
                            width = random.randint(int(self.data["minblocksize"]),int(self.data["maxblocksize"])),\
                            height = random.randint(int(self.data["minblocksize"]),int(self.data["maxblocksize"])),\
                            color= self.data["blockcolor"],\
                            speed = speed, accel = accel,\
                            direction = "".join([random.choice("ns"),random.choice("ew")]),\
                            blocks = blocks,\
                            mainrect = mainrect,frame=frame,fps=fps)

        obj.Mainrect(self, x=c_xcenter, y=c_ycenter,\
                        width = 40, height = 40, color= self.data["maincolor"],\
                        blocks = blocks,\
                        mainrect = mainrect,fps=fps)

    def colision(self):
        self.configure(bg = self.data["failcolor"])
        self.timer.stop()
        font = tkFont.Font(size="16",weight = "bold")
        b = Tkinter.Button(self, text = self.texts["newgame"],font=font,\
                           command = self.reboot)
        self.create_window(int(self.data["width"])/2,\
                           int(self.data["height"])/2,\
                           window = b)
    def start(self):
        self.timer.start()

class Game(Tkinter.Frame):
    def __init__(self,root,reboot = None,speedentry = None,\
                 accelentry=None, texts=None, *args, **kwrds):
        self.texts = texts
        Tkinter.Frame.__init__(self,root,*args, **kwrds)
        self.gcanv = Gcanvas(self,reboot=reboot,speedentry = speedentry,\
                             accelentry=accelentry,texts = texts)
        self.gcanv.grid(column=0,row=0,rowspan=2,sticky=Tkinter.W)

        font = tkFont.Font(size="24",weight = "bold")
        self.tlabel = Tkinter.Label(self, text = self.texts["time"],\
                                    font = font)
        self.tlabel.grid(column=1,row=0,sticky=Tkinter.S, ipadx=10, ipady=10)
        self.t = someshit.Timer(self,font=font)
        self.gcanv.timer = self.t
        self.t.grid(column=1,row=1,sticky=Tkinter.N, ipadx=10, ipady=10)

class Myentry(Tkinter.Frame):
    def __init__(self,root, number = 0,text = ""):
        self.root = root
        Tkinter.Frame.__init__(self,root)
        self.num = number
        self.label = Tkinter.Label(self, text = text)
        self.label.grid(column=0,row=0)
        
        self.var = Tkinter.StringVar()
        self.var.set(str(number))
        self.entry = Tkinter.Entry(self,textvariable = self.var,\
                                   exportselection = 0)
        self.entry.grid(column=1,row=0)
    def get(self):
        s = self.var.get()
        if s.isalnum():
            return int(s)
        else:
            self.var.set(str(self.num))
            return self.num

class Window():
    def __init__(self):
        self.texts = someshit.readtexts()
        self.root = Tkinter.Tk()
        self.root.title(self.texts["title"])
        self.topframe = Tkinter.Frame(self.root)
        self.topframe.grid(column=0,row=0,\
                           sticky=Tkinter.W,\
                           ipadx=10, ipady=10)
        
        self.speedentry = Myentry( self.topframe, number = 250,\
                                   text =self.texts["speed"])
        self.speedentry.grid(column=0,row=0,\
                             sticky=Tkinter.W, ipadx=10, ipady=10)

        self.accelentry = Myentry(self.topframe, number = 0,\
                                  text = self.texts["accel"])
        self.accelentry.grid(column=1,row=0, ipadx=10, ipady=10)

        self.rulesbutton = Tkinter.Button(self.topframe,\
                                          text = self.texts["rulesbutton"],\
                                          command = self.rules)
        self.rulesbutton.grid(column=2,row=0, padx=10, pady=10,\
                              sticky=Tkinter.S)

        self.game = Game(self.root,reboot = self.reboot,\
                         speedentry = self.speedentry,\
                         accelentry =self.accelentry, texts=self.texts )
        self.game.grid(column=0,row=1)

    def reboot(self):
        self.game.destroy()
        self.game = Game(self.root,reboot = self.reboot,\
                         speedentry = self.speedentry,\
                         accelentry =self.accelentry, texts=self.texts )
        self.game.grid(column=0,row=1)
    def rules(self):
        top = Tkinter.Toplevel()
        top.title(self.texts["rulestitle"])
        Tkinter.Label(top,width = "90", text = self.texts["rules"]).grid()
        

if __name__=="__main__":
    w = Window()
    w.root.mainloop()
        
