# -*- coding: UTF-8 -*-
#Игра для пилотов
import Tkinter

class Rect():
    def __init__(self, root, x=0,y=0,width=0,height=0,fps=30, color="red",\
                 blocks=[],mainrect = []):
        self.size = complex(width, height)
        self.coord = complex(x,y)
        self.canv = Tkinter.Canvas(root, width = width, height = height,\
                       bg=color, bd=0)
        self.wind_id = root.create_window(x,y, window = self.canv)
        self.parent = root
        self.blocks = blocks
        self.mainrect = mainrect
        self.fps=fps
        
    def __first(self):
        return self.coord-self.size/2
    def __second(self):
        return self.coord+self.size/2
    def left(self):
        return self.__first().real
    def right(self):
        return self.__second().real
    def bottom(self):
        return self.__second().imag
    def top(self):
        return self.__first().imag
    def intersect(self, rect2):
        return not self.notintersect(rect2)
    def notintersect(self, rect2):
        return self.right()<rect2.left() or self.left()>rect2.right() \
               or self.bottom()<rect2.top() or self.top()>rect2.bottom()
    def move(self, moving):
        old = self.coord
        self.coord = moving+self.coord
        if int(self.coord.real)!=int(old.real) or int(self.coord.imag)!=int(old.imag):
            self.parent.coords(self.wind_id, int(self.coord.real),\
                               int(self.coord.imag))
    def colision(self):
        for x in self.blocks:
            x.stop()
        if self.mainrect!=[]:
            self.mainrect[0].stop()
        self.parent.colision()
    def stop(self):
        self.travel = False
    
class Movingrect(Rect):
    def __init__(self,root, speed = 0, accel = 0, direction=None,\
                 frame = complex(100,100), **kwrds):
        if direction == "nw":
            self.speed = complex(-speed, -speed)
        elif direction =="ne":
            self.speed = complex(speed, -speed)
        elif direction =="se":
            self.speed = complex(speed, speed)
        elif direction =="sw":
            self.speed = complex(-speed, speed)
        else:
            self.speed = complex(0,0)
        self.accel = accel
        self.travel = False
        self.frame = frame
        Rect.__init__(self,root,**kwrds)
        self.step()
        self.blocks.append(self)
    def __accelerate(self):
        def increm(a,b):
            if a>=0:
                return a+b
            else:
                return a-b
        xs = self.speed.real
        ys = self.speed.imag
        d= self.accel/self.fps
        self.speed = complex(increm(xs,d), increm(ys,d))
    def __r_x2plus(self):
        if self.speed.real<0:
            self.speed = -self.speed.conjugate()
    def __r_x2minus(self):
        if self.speed.real>0:
            self.speed = -self.speed.conjugate()
    def __r_y2plus(self):
        if self.speed.imag<0:
            self.speed = self.speed.conjugate()
    def __r_y2minus(self):
        if self.speed.imag>0:
            self.speed = self.speed.conjugate()
    def __reflect(self):
        if self.left()<0: self.__r_x2plus()
        elif self.frame.real<self.right(): self.__r_x2minus()
        
        if self.top()<0: self.__r_y2plus()
        elif self.frame.imag<self.bottom(): self.__r_y2minus()

    def check_colision(self):
        if self.mainrect!=[]:
            if self.intersect(self.mainrect[0]):
                self.colision()
        
    def step(self):
        if self.travel:
            self.move(self.speed/self.fps)
            self.__reflect()
            self.__accelerate()
            self.check_colision()
        self.after_id = self.canv.after(int(1000/self.fps),  func = self.step)
        
    def start(self):
        self.travel = True


class Mainrect(Rect):
    def __init__(self, root, **kwrds):
        self.clicked = False
        self.started = False
        Rect.__init__(self,root,**kwrds)
        self.canv.bind("<Button-1>",self.click)
        self.canv.bind("<Motion>", self.mousemove)
        self.canv.bind("<ButtonRelease-1>", self.release)
        self.travel = True
        self.mainrect.append(self)
    def click(self, event):
        if not self.started:
            self.start()
            self.started = True
        self.click_coord = complex(event.x, event.y)
        self.clicked = True
    def release(self, event):
        self.clicked = False
    def check_colision(self):
        for x in self.blocks:
            if x.intersect(self):
                self.colision()
    def mousemove(self, event):
        if self.clicked and self.travel:
            co = complex(event.x, event.y)
            if co!=self.click_coord:
                m = co-self.click_coord
                self.move(m)
                self.check_colision()

    def start(self):
        for x in self.blocks:
            x.start()
        self.parent.start()

if __name__=="__main__":
    print "RUN THE Asteroid.pyw FILE!"
    a=raw_input("Press enter to continue")
